Tonyu.klass.define({
  fullName: 'user.Circle',
  shortName: 'Circle',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Circle_main() {
        "use strict";
        var _this=this;
        
        
      },
      fiber$main :function _trc_Circle_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        
        _thread.retVal=_this;return;
      },
      draw :function _trc_Circle_draw(ctx) {
        "use strict";
        var _this=this;
        
        ctx.strokeStyle=_this.col||"white";
        ctx.beginPath();
        ctx.arc(_this.x,_this.y,_this.radius,0,Tonyu.globals.$Math.PI*2);
        ctx.closePath();
        ctx.stroke();
      },
      tangentsFrom :function _trc_Circle_tangentsFrom(p) {
        "use strict";
        var _this=this;
        var po;
        var ot;
        var pt;
        var tpo;
        
        po = p.sub(_this.position).length;
        
        ot = _this.radius;
        
        pt = _this.sqrt(po*po-ot*ot);
        
        tpo = _this.atanxy(pt,ot);
        
      },
      fiber$tangentsFrom :function _trc_Circle_f_tangentsFrom(_thread,p) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var po;
        var ot;
        var pt;
        var tpo;
        
        po = p.sub(_this.position).length;
        
        ot = _this.radius;
        
        pt = _this.sqrt(po*po-ot*ot);
        
        tpo = _this.atanxy(pt,ot);
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"draw":{"nowait":true},"tangentsFrom":{"nowait":false}},"fields":{"col":{}}}
});
Tonyu.klass.define({
  fullName: 'user.LineSeg',
  shortName: 'LineSeg',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_LineSeg_main() {
        "use strict";
        var _this=this;
        
        
        
        
      },
      fiber$main :function _trc_LineSeg_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        
        
        
        _thread.retVal=_this;return;
      },
      __getter__dir :function _trc_LineSeg___getter__dir() {
        "use strict";
        var _this=this;
        
        return _this.d.sub(_this.s);
      },
      draw :function _trc_LineSeg_draw(ctx) {
        "use strict";
        var _this=this;
        
        ctx.strokeStyle=_this.col||"white";
        ctx.beginPath();
        ctx.moveTo(_this.s.x,_this.s.y);
        ctx.lineTo(_this.d.x,_this.d.y);
        ctx.closePath();
        ctx.stroke();
      },
      __getter__trans :function _trc_LineSeg___getter__trans() {
        "use strict";
        var _this=this;
        var bx;
        
        bx = _this.dir.normalize();
        
        return new Tonyu.classes.user.Trans({origin: _this.s,base: {x: bx,y: bx.rotate(90)}});
      },
      distToCircle :function _trc_LineSeg_distToCircle(c) {
        "use strict";
        var _this=this;
        var t;
        var l;
        
        t = _this.trans;
        
        l = t.worldToLocal(c);
        
        return l.y;
      },
      fiber$distToCircle :function _trc_LineSeg_f_distToCircle(_thread,c) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var t;
        var l;
        
        t = _this.trans;
        
        l = t.worldToLocal(c);
        
        _thread.retVal=l.y;return;
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"__getter__dir":{"nowait":true},"draw":{"nowait":true},"__getter__trans":{"nowait":true},"distToCircle":{"nowait":false}},"fields":{"s":{},"col":{},"d":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Main',
  shortName: 'Main',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.Actor,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Main_main() {
        "use strict";
        var _this=this;
        
        _this.c = new Tonyu.classes.user.Circle({x: 100,y: 200,radius: 20,col: "cyan"});
        
        _this.l = new Tonyu.classes.user.LineSeg({s: new Tonyu.classes.kernel.Vec3(50,80),d: new Tonyu.classes.kernel.Vec3(200,130)});
        
        _this.x=_this.y=150;
        _this.pad = new Tonyu.classes.kernel.APad;
        
        while (true) {
          Tonyu.checkLoop();
          _this.x+=_this.pad.vx;
          _this.y+=_this.pad.vy;
          _this.l.d=_this.position;
          _this.text="D="+_this.floor(_this.l.distToCircle(_this.c));
          _this.update();
          
        }
      },
      fiber$main :function _trc_Main_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        _this.c = new Tonyu.classes.user.Circle({x: 100,y: 200,radius: 20,col: "cyan"});
        
        _this.l = new Tonyu.classes.user.LineSeg({s: new Tonyu.classes.kernel.Vec3(50,80),d: new Tonyu.classes.kernel.Vec3(200,130)});
        
        _this.x=_this.y=150;
        _this.pad = new Tonyu.classes.kernel.APad;
        
        
        _thread.enter(function _trc_Main_ent_main(_thread) {
          if (_thread.lastEx) __pc=_thread.catchPC;
          for(var __cnt=100 ; __cnt--;) {
            switch (__pc) {
            case 0:
            case 1:
              _this.x+=_this.pad.vx;
              _this.y+=_this.pad.vy;
              _this.l.d=_this.position;
              _this.text="D="+_this.floor(_this.l.distToCircle(_this.c));
              _this.fiber$update(_thread);
              __pc=2;return;
            case 2:
              
              __pc=1;break;
            case 3     :
              
              _thread.exit(_this);return;
            }
          }
        });
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false}},"fields":{"c":{},"l":{},"pad":{}}}
});
Tonyu.klass.define({
  fullName: 'user.Trans',
  shortName: 'Trans',
  namespace: 'user',
  superclass: Tonyu.classes.kernel.TObject,
  includes: [],
  methods: function (__superClass) {
    return {
      main :function _trc_Trans_main() {
        "use strict";
        var _this=this;
        
        
        
      },
      fiber$main :function _trc_Trans_f_main(_thread) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        
        
        
        
        _thread.retVal=_this;return;
      },
      localToWorld :function _trc_Trans_localToWorld(pos) {
        "use strict";
        var _this=this;
        var b;
        
        b = _this.base;
        
        return b.x.mul(pos.x).addX(b.y.mul(pos.y)).addX(_this.origin);
      },
      fiber$localToWorld :function _trc_Trans_f_localToWorld(_thread,pos) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var b;
        
        b = _this.base;
        
        _thread.retVal=b.x.mul(pos.x).addX(b.y.mul(pos.y)).addX(_this.origin);return;
        
        
        _thread.retVal=_this;return;
      },
      worldToLocal :function _trc_Trans_worldToLocal(pos) {
        "use strict";
        var _this=this;
        var b;
        var det;
        
        b = _this.base;
        
        pos=new Tonyu.classes.kernel.Vec3(pos.x,pos.y);
        pos=_this.origin.mul(- 1).addX(pos);
        det = b.x.x*b.y.y-b.y.x*b.x.y;
        
        return new Tonyu.classes.kernel.Vec3(b.y.y*pos.x-b.y.x*pos.y,- b.x.y*pos.x+b.x.x*pos.y).divX(det);
      },
      fiber$worldToLocal :function _trc_Trans_f_worldToLocal(_thread,pos) {
        "use strict";
        var _this=this;
        //var _arguments=Tonyu.A(arguments);
        var __pc=0;
        var b;
        var det;
        
        b = _this.base;
        
        pos=new Tonyu.classes.kernel.Vec3(pos.x,pos.y);
        pos=_this.origin.mul(- 1).addX(pos);
        det = b.x.x*b.y.y-b.y.x*b.x.y;
        
        _thread.retVal=new Tonyu.classes.kernel.Vec3(b.y.y*pos.x-b.y.x*pos.y,- b.x.y*pos.x+b.x.x*pos.y).divX(det);return;
        
        
        _thread.retVal=_this;return;
      },
      __dummy: false
    };
  },
  decls: {"methods":{"main":{"nowait":false},"localToWorld":{"nowait":false},"worldToLocal":{"nowait":false}},"fields":{"base":{},"origin":{}}}
});

//# sourceMappingURL=concat.js.map